c
	subroutine chpar
c
c	subroutine to change cont,baseline, or band parameters
c
c	ipmin,ipmax,ivtic   for  display
c	ihmin,ihmax,ihtic   for display
c	baseline constant
c	type of continuum   g gauss  p polynomial   n none  s straight line
c       p0,p1,p2  for continuum
c	number of bands
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	etc
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	INTEGER*4 ITEMP1(94),ITEMP2(94)
	REAL*4    PTEMP(94)
	real*8 g(1536,94)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),dispd,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	LOGICAL*1 ITIME(8),YES,NO,ANS
	LOGICAL*1 IHY,IHN,IHX,IB,IDATE(9),ESCAPE
	LOGICAL*1 TEXT(72,16)
	LOGICAL*1 DOT,DBYTE,ABYTE,TBYTE
C
	DATA YES,NO,IHX/'Y','N',1HX/
C
	CALL DATE(IDATE)
C
10	call clrscr
c
	CALL TIME(ITIME)
C
	WRITE(*,9000)IDATE,ITIME
9000	FORMAT(//4X,9A1,4X,'=====  Change MGM-Fit Parameters  '
	1 ,'=====',4X,8A1)
c
c	now write menu
c
	write(*,9020)
9020	format(///'  Select:  1 - Change Continuum Type'/
	2         '           2 - Change Continuum Parameters'/
	2         '           3 - Change An Absorption'/
	2         '           4 - Add An Absorption'/
	2         '           5 - Delete An Absorption'/
	2         '           6 - Display'/
	2         '           7 - Main Menu   > '$)
c
	read(*,9025,ERR=10)I1
9025	format(I4)	
	if(i1.lt.1.or.i1.gt.9)goto 10
	goto(200,300,400,500,600,800,900)I1
c
900	return
c
800	call display
	goto 10	
c
c	change continuum type
c
200	IF(CONTYP.EQ.'N')write(*,9040)
	IF(CONTYP.EQ.'P')write(*,9045)
	IF(CONTYP.EQ.'Q')write(*,9050)
	IF(CONTYP.EQ.'G')write(*,9055)
	IF(CONTYP.EQ.'S')write(*,9060)swav1,swav2
	IF(CONTYP.EQ.'T')write(*,9065)swav1,swav2
c
9040	format(/' No Continuum ')
9045	format(/' Polynomial Continuum in Wavelength Space '$)
9050	format(/' Polynomial Continuum in Wavenumber Space '$)
9055	format(/' Gaussian Continuum '$)
9060	format(/' Straight line removed in Wavelength '2F7.0,$)
9065	format(/' Straight line removed in Wavenumber '2F7.0,$)
9070	format(' P0= 'E15.8'  P1= 'E15.8'  P2= 'E15.8'  P3= 'E15.8)
c
	read(*,9033)ans
	call low2up(ans)
9032	format(4E15.7)
9033	format(1A1)
	if(ans.eq.' ')goto 10
	contyp=ans
	goto 10
c
c	change continuum parameters
c
300	if(contyp.eq.'N')goto 10     ! no parameters to change
	IF(CONTYP.EQ.'S')write(*,9060)swav1,swav2
	IF(CONTYP.EQ.'T')write(*,9065)swav1,swav2
	IF(CONTYP.EQ.'P')write(*,9070)cp0,cp1,cp2,cp3
	IF(CONTYP.EQ.'Q')write(*,9070)cp0,cp1,cp2,cp3
	read(*,9032,err=300)p0,p1,p2,p3
C
	IF(CONTYP.EQ.'S'.OR.CONTYP.EQ.'T')GOTO 320
	IF(CONTYP.EQ.'P'.OR.CONTYP.EQ.'Q')GOTO 360
	GOTO 2000
C
C	STRAIGHT LINE REASSIGN
C
320	IF(P0.NE.0)SWAV1=P0
	IF(P1.NE.0)SWAV2=P1
	GOTO 2000
C
C	POLYNOMIAL REASSIGN
C	
360	IF(P0.NE.0.0)CP0=P0
	IF(P1.NE.0.0)CP1=P1
	IF(P2.NE.0.0)CP2=P2
	IF(P3.NE.0.0)CP3=P3
	goto 2000                    ! recalculate
c
c	change a band parameters
c
400	write(*,9080)
9080	format(/' Which Absorption ? '$)
	read(*,9025,ERR=400)k
	if(k.eq.0)goto 10
	if(k.gt.nbands)goto 10
c   
410	write(*,9090)k,gcent(k),gfwhm(k),gstr(k)
9090	format(2X,I2'  Center= 'E15.8'   FWHM= 'E15.8'   Str= 'E15.8)
c
	read(*,9032,ERR=410)p0,p1,p2
	if(p0.ne.0.0)gcent(k)=p0
	if(p1.ne.0.0)gfwhm(k)=p1
	if(p2.ne.0.0)gstr(k)=p2
	goto 2000
c
c	add an absorption
c
500	continue
	write(*,9100)
9100	format(/' Enter Center in NM: '$)
	read(*,*,ERR=500)p0
505	write(*,9105)
9105	format(' Enter FWHM in nanometers. : '$) 
	read(*,*,ERR=505)p1
510	write(*,9110)
9110	format(' Enter Strength : '$)
	read(*,*,ERR=510)p2
c
c	move other params to temp arrays
c
	do 520 j=92,(2*nbands)+1,-1
c
	itemp1(j+2)=ipstat(j,1)      ! move up 2
	itemp2(j+2)=ipstat(j,2)      ! move up 2
	ptemp(j+2)=params(j)
520	continue
c
	do 530 j=2*nbands,nbands+1,-1
c
	itemp1(j+1)=ipstat(j,1)      ! move up 1
	itemp2(j+1)=ipstat(j,2)      ! move up 1
	ptemp(j+1)=params(j)
c
530	continue
c
	do 540 	j=1,nbands
	itemp1(j)=ipstat(j,1)     
	itemp2(j)=ipstat(j,2)      ! don't move
	ptemp(j)=params(j)
540	continue
c
c
	nbands=nbands+1
	nparam=3*nbands
	gcent(nbands)=p0
	gfwhm(nbands)=p1
	gstr(nbands)=p2
c
c	assume parameters unlocked
c
	itemp1(nbands)=0
	itemp1(2*nbands)=0
	itemp1(3*nbands)=0
c
	do 550 j=1,94
	ipstat(j,1)=itemp1(j)
	ipstat(j,2)=itemp2(j)     ! restore used parameters
	params(j)=ptemp(j)
550	continue
c
	call filstat            ! refill derivative array
c
	goto 2000		! recalulate
c
c	delete an absorption
c
600	write(*,9180)
9180	format(/' Which Absorption ? '$)
	read(*,9025,ERR=600)k
	if(k.eq.0)goto 10
	if(k.gt.nbands)goto 10
c   
	write(*,9090)k,gcent(k),gfwhm(k),gstr(k)
c
	write(*,9120)
9120	format(/' Delete This Absorption ? '$)
	read(*,9033)ans
	call low2up(ans)
	if(ans.eq.no)goto 10
c
c	delete Absorption # k
c
	index=0
	do 610 j=1,94
	if(j.eq.k)goto 610  ! skip deleted center
	if(j.eq.k+nbands)goto 610  ! skip deleted width
	if(j.eq.k+nbands+nbands)goto 610  ! skip deleted strength
c
	index=index+1
	itemp1(index)=ipstat(j,1)
	itemp2(index)=ipstat(j,2)
	ptemp(index)=params(j)
c
610	continue
c
	do 620 j=1,91
	ipstat(j,1)=itemp1(j)
	ipstat(j,2)=itemp2(j)     ! restore used parameters
	params(j)=ptemp(j)
620	continue
c
	nbands=nbands-1
	nparam=3*nbands
c
	call unshuffl
	goto 2000              ! recalulate
c
c	recalculate everything
c
2000	continue
C
	nparam=3*nbands
C
C	SET CLEAR POLYNOMIAL PARAMETERS
C
	IF(CONTYP.EQ.'P')GOTO 1000     ! polynomial in wavelength space
	IF(CONTYP.EQ.'Q')GOTO 1600     ! polynomial in wavenumber space
	IF(CONTYP.EQ.'S')GOTO 1300     ! STRAIGHT LINE REMOVAL IN WAVEL SPACE
	IF(CONTYP.EQ.'T')GOTO 1500     ! STRAIGHT LINE IN WAVEN SPACE
C
	GOTO 1400
C
C	POLYNOMIAL CONT IN WAVELENGTH SPACE
C
1000	continue
	GOTO 1400
C
C	POLYNOMIAL CONT IN WAVENUMBER SPACE
C
1600	continue
	GOTO 1400
C
C	STRAIGHT LINE CONTINUUM REMOVAL IN WAVELENGTH SPACE
C
1300	CALL SREMOVE(NPNTS,SWAV1,SWAV2,WAVEL,RATIO)
	CP0=CONST
	CP1=SLOPE
	CP2=0.0
	CP3=0.0
C
	GOTO 1400
C
C	STRAIGHT LINE CONTINUUM REMOVAL IN WAVENUMBER SPACE
C
1500	CALL TREMOVE(NPNTS,SWAV1,SWAV2,WAVEN,RATIO)
	CP0=CONST
	CP1=SLOPE
	CP2=0.0
	CP3=0.0
	GOTO 1400
C
1400	continue
	CALL FILLUP         ! FILL UP THE ARRAYS
C
	GOTO 10             ! back to menu
c
	END
c
	subroutine lockup
c
c	subroutine to  lock/onlock parameters
c
c	ipmin,ipmax,ivtic   for  display
c	ihmin,ihmax,ihtic   for display
c	baseline constant
c	type of continuum   g gauss  p polynomial   n none  s straight line
c       p0,p1,p2  for continuum
c	number of absorptions 
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	etc
c
	common/misc/volt,slope,const,swav1,swav2
c
		common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
 	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),dispd,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	LOGICAL*1 ITIME(8),YES,NO,ANS
	LOGICAL*1 IHY,IHN,IHX,IB,IDATE(9),ESCAPE
	LOGICAL*1 TEXT(72,16)
	LOGICAL*1 DOT,DBYTE,ABYTE,TBYTE
C
	DATA YES,NO,IHX/'Y','N',1HX/
C
	CALL DATE(IDATE)
C
10	call clrscr
c
	CALL TIME(ITIME)
C
	WRITE(*,9000)IDATE,ITIME
9000	FORMAT(//4X,9A1,3X,'=====  Lock/Unlock MGM-Fit Parameters  '
	1 ,'=====',3X,8A1)
c
c	now write menu
c
	write(*,9020)
9020	format(///'  Select:  1 - Lock All Bandcenters'/
	2         '           2 - Unlock All Bandcenters'/
	2         '           3 - Lock All Bandwidths'/
	2         '           4 - Unlock All Bandwidths'/
	2         '           5 - Lock All Strengths'/
	2         '           6 - Unlock All Strengths'/
	2         '           7 - Lock Polynomial Constants'/
	2         '           8 - Unlock Non-Zero Polynomials'/
	2         '           9 - Lock An Individual Parameter'/
	2         '          10 - Unlock An Individual Parameter'/
	2         '          11 - Lock An Individual Absorption'/
	2         '          12 - Unlock An Individual Absorption'/
	2         '          13 - Display Current Parameter Status'/
	2         '          14 - Exit       > '$)
c
	read(*,9025,ERR=10)I1
9025	format(I4)	
	if(i1.lt.1.or.i1.gt.14)goto 10
	goto(100,200,300,400,500,600,700,800,
	2 900,1000,1100,1200,1300,1400)I1
c
1400	return
c
c	lock centers
c
100	continue
	do 110 k=1,nbands
	ipstat(k,1)=1         ! lock centers
110	continue
	goto 10
c
c
c	unlock centers
c
200	continue
	do 210 k=1,nbands
	ipstat(k,1)=0         ! unlock centers
210	continue
	goto 10
c
c	lock widths
c
300	continue
	do 310 k=nbands+1,2*nbands
	ipstat(k,1)=1         ! lock widths
310	continue
	goto 10
c
c
c	unlock widths
c
400	continue
	do 410 k=nbands+1,2*nbands
	ipstat(k,1)=0         ! unlock widths
410	continue
	goto 10
c
c	lock strengths
c
500	continue
	do 510 k=(2*nbands)+1,3*nbands
	ipstat(k,1)=1         ! lock strengths
510	continue
	goto 10
c
c	lock strengths
c
600	continue
	do 610 k=(2*nbands)+1,3*nbands
	ipstat(k,1)=0         ! unlock strengths
610	continue
	goto 10
c
c	lock polylomial parameters
c
700	continue
c
	ipstat(nparam+1,1)=1	
	ipstat(nparam+2,1)=1	
	ipstat(nparam+3,1)=1	
	ipstat(nparam+4,1)=1	
	goto 10
c
c	unlock nonzero polynomial constants
c
800	continue
c
	IF(CONTYP.EQ.'G')GOTO 10     ! can't unlock absorption param
c
	if(cp0.ne.0)ipstat(nparam+1,1)=0	
	if(cp1.ne.0)ipstat(nparam+2,1)=0	
	if(cp2.ne.0)ipstat(nparam+3,1)=0	
	if(cp3.ne.0)ipstat(nparam+4,1)=0	
	goto 10
c
c	lock an individual parameter
c
900	continue
	write(*,5000)
5000	format(/'  Centers are    1 - nbands'/
	2       '  Widths  are  nbands+1 - 2*nbands'/
	2	'  Strengths are 2*nbands+1 - 3*nbands'/
	2       '  CpN   is  3*nbands+N   >  '$)
	read(*,9025,err=900)ipar
	if(ipar.lt.1)goto 10
	if(ipar.gt.nparam+4)goto 900   ! reprompt
	ipstat(ipar,1)=1            ! lock it
	goto 10
c
c	unlock an individual parameter
c
1000	continue
	write(*,5000)
	read(*,9025,err=900)ipar
	if(ipar.lt.1)goto 10
	if(ipar.gt.nparam.and.contyp.eq.'G')goto 10
	if(ipar.gt.nparam+4)goto 1000
	ipstat(ipar,1)=0              ! unlock it
	goto 10
c
c	lock an absorption
c
5001	format(/'  Lock Absorption #? '$)
1100	continue
	write(*,5001)
	read(*,9025,err=900)ipar
	if(ipar.lt.1)goto 10
	if(ipar.gt.nbands)goto 1100
	ipstat(ipar,1)=1              ! lock it
	ipstat(ipar+nbands,1)=1              ! lock it
	ipstat(ipar+nbands+nbands,1)=1              ! lock it
	goto 1100
c
c	lock an absorption
c
5002	format(/'  Unlock Absorption #? '$)
1200	continue
	write(*,5002)
	read(*,9025,err=900)ipar
	if(ipar.lt.1)goto 10
	if(ipar.gt.nbands)goto 1200
	ipstat(ipar,1)=0              ! unlock it
	ipstat(ipar+nbands,1)=0              ! unlock it
	ipstat(ipar+nbands+nbands,1)=0              ! unlock it
	goto 1200
c
1300	call liststat
	goto 10
c
	end
