c
	subroutine DISPLAY
c
c	subroutine to DISPLAY GRAPHS AND/OR RESET DISPLAY PARAMETERS
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT,RTEMP(1536)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC,IHTC,IPEN,ISYM,ILT,ICDOT
	LOGICAL*1 TITLE(50),ANSWERS(12),IDATE(9),ITIME(8),YES,NO
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,dispi,
	2 dispd,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2,IHLABL
	DATA      YES,NO/'Y','N'/
C
	IHLABL=1
	IPLOT=0            ! ASSUME SCREEN EMPTY
	CALL DATE(IDATE)
C
10	CALL CLRSCR
	CALL TIME(ITIME)
	WRITE(5,9000)IDATE,ITIME
9000	FORMAT(//1X,9A1,8X,'=====  MGM-FIT  Display Routines '
	1 ,'=====',8X,8A1,//)
C	write menu
C
	WRITE(*,9700)
9700	FORMAT(//,'   Select: 1-Display Graph in Wavelength Space'/
	2         '           2-Display Graph in Wavenumber Space'/
	2         '           3-Reset Grid Parameters'/
	2         '           4-Reselect Curves'/
	2         '           5-Dump to HP7550'/
	2         '           6-Exit Display        > '$)
C
	READ(*,8020,err=10)I1
8020	FORMAT(2I6)
	IF(I1.LT.1.OR.I1.GT.6) GOTO 10
	GOTO( 720,720,750,900,1000,800)I1
C
C	DRAW GRAPHS
C
720	CONTINUE
C
	IPLTYP=I1
	IHLABL=I1
	IF(iscan.eq.3)IPLTYP=3	! WAVENUMBER file
	ILABTYP=6               ! NATURAL LOG REFLECTANCE PLOT
C
C
	if(ipltyp.eq.iplot)call tekon   ! flip to graph
	if(ipltyp.eq.iplot)goto 737     ! skip to prompt
c	
	iplot=ipltyp
	IF(IPLTYP.EQ.1)
	2 CALL DGRID(IPMIN,IPMAX,IWMIN,IWMAX,
	2 IVTIC,IHTIC,ILABTYP,IPLTYP)
C
	IHTC=IHTIC
	IF(iscan.NE.3.AND.IPLTYP.GE.2)IHTC=-99  ! AUTO TICS FOR CONVRSION PLOT
	IF(IPLTYP.GE.2)
	2 CALL DGRID2(IPMIN,IPMAX,IWMIN,IWMAX,
	2 IVTIC,IHTC,ILABTYP,IPLTYP)
C
C	WRITE TITLE
C
	IX=700
	IY=2780
	NCHAR=50
	size=2.5
	call symbla(nchar,title,ix,iy,size,size,0.0,0.0,0)
C
C	draw spectra
C
	ICDOT=0
	ISYM=11    ! dots
	IF(DISPS.EQ.YES)CALL DPOINTS(NPNTS,WAVEL,RATIO,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
C
C	draw  combined bands
C
	ICDOT=1
	ISYM=0
	IF(DISPG.EQ.YES)CALL DPOINTS(NPNTS,WAVEL,GLINE,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
C
C	draw residual
C
	DO 726 K3=1,NPNTS
	RTEMP(K3)=RESID(K3)+.10
726	CONTINUE
	IF(DISPRS.EQ.YES)CALL DPOINTS(NPNTS,WAVEL,RTEMP,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
C
C	draw fit
C
	IF(DISPF.EQ.YES)CALL DPOINTS(NPNTS,WAVEL,FIT,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
C
C	draw continuum
C
	IF(DISPC.EQ.YES)CALL DPOINTS(NPNTS,WAVEL,CONT,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
C
C	draw ratio-CONT
C
	IF(DISPRM.EQ.YES)CALL DPOINTS(NPNTS,WAVEL,RCONT,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
C
C	DRAW THE INDIVIDUAL BANDS
C
	IF(DISPI.NE.YES)GOTO 737
	DO 735 K2=1,nbands
	DO 736 K3=1,NPNTS
	RTEMP(K3)=GAUSS(K2,K3)
736	CONTINUE
	CALL DPOINTS(NPNTS,WAVEL,RTEMP,ISYM,ICDOT,
	2 IPMIN,IPMAX,IWMIN,IWMAX,IPLTYP)
735	CONTINUE
C
737	CALL HOME
	call anmode
	READ(*,5001)IDUM
5001	FORMAT(A1)
	CALL tekff
C
	GOTO 10	! RETURN TO SELECT SECTION
C	
C	WRITE TEXT ON SCREEN
C
750	CONTINUE	
	IPLOT=0
1810	WRITE(*,7250)
7250	FORMAT(/' Enter Ipmin,Ipmax,Ivtic: '$)
7260	FORMAT(3I6)
	READ(*,7260)IPMNT,IPMXT,IVT
	IF(IPMXT.EQ.0)GOTO 1850         ! SAME VERTICAL SCALE         		
	IF(IVT.EQ.0)GOTO 1810           ! MUST HAVE TIC MARKS
C
	IPMIN=IPMNT
	IPMAX=IPMXT
	IVTIC=IVT
C
C	SET HORIZONTAL SCALE
C
C
1850	WRITE(*,7252)
7252	FORMAT(/' Enter Iwmin,Iwmax,Ihtic: '$)
	READ(*,7260)IWMNT,IWMXT,IHT
	IF(IWMXT.EQ.0)GOTO 10          ! SAME HORIZONTAL SCALE
	IF(IHT.EQ.0)GOTO 1850           ! MUST HAVE TIC MARKS
C
	IWMIN=IWMNT
	IWMAX=IWMXT
	IHTIC=IHT
	GOTO 10
C
C	FIND OUT WHICH CURVES TO DISPLAY
C
900	CONTINUE
	DO 1880 K=1,12
1880	ANSWERS(K)=' '
C
	WRITE(*,7275)
7275	FORMAT(/' Select Curves to be Displayed'
	2      /'   S(pectra),B(ands),I(ndivid. Bands), R(Spec-Cont)'
	2      /'   F(it),C(ontinuum),E(Spec-Fit): '$)
C
	READ(*,7280)ANSWERS
7280	FORMAT(16A1)
	IF(ANSWERS(1).EQ.' ')GOTO 10
C
C	CLEAR DISPLAY FLAGS
C
	IPLOT=0            ! ASSUME SCREEN EMPTY
	DISPD=NO
	DISPS=NO
	DISPG=NO
	DISPI=NO
	DISPF=NO
	DISPC=NO
	DISPRM=NO
	DISPRS=NO
C
	DO 1890 K=1,12
	  CALL LOW2UP(ANSWERS(K))
	  IF(ANSWERS(K).EQ.'S')DISPS=YES	! SPECTRA
	  IF(ANSWERS(K).EQ.'F')DISPF=YES	! FIT
	  IF(ANSWERS(K).EQ.'B')DISPG=YES	! COMBINED BANDS
	  IF(ANSWERS(K).EQ.'I')DISPI=YES	! INDIVIDUAL BANDS
	  IF(ANSWERS(K).EQ.'C')DISPC=YES	! CONTINUUM
	  IF(ANSWERS(K).EQ.'R')DISPRM=YES	! REMAIN (SPEC-CONT)
	  IF(ANSWERS(K).EQ.'E')DISPRS=YES       ! RESIDUAL (SPEC-FIT)
1890	CONTINUE
C
	GOTO 10     ! RETURN TO MENU
C
C	hp7550 dump
C
1000	CONTINUE
C
	write(*,5027)
5027	format(/'  Sorry   No Plotter on the Alpha   '$)
	read(*,5001)IDUM
C
	GOTO 10	! RETURN TO SELECT SECTION
C
C-----GRACEFULL EXIT
C
800	CONTINUE
	RETURN
	END
