c
	subroutine fillup
c
c	subroutine to FILL ALL THE GFIT ARRAYS
c
	common/databl/RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),dispd,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
C
	wconst=2.354820
C
	call shuffl
C
C	THEN BUILD THE INDIVIDUAL BANDS
C	
C	DO 90 K=1,nbands
C90	WRITE(*,*)GCENT(K),GCENTN(K),GFWHM(K),GWIDTH(K),GSTR(K)	
C
	DO 100 K=1,nbands
	DO 150 J=1,NPNTS
	GAUSS(K,J)=CGAUSS(CNRT(K),SGSQ(K),GSTR(K),WVRT(J))
150	CONTINUE
100	CONTINUE
C
C	CALCULATE SUM OF THE BANDS
C
	DO 220 J=1,NPNTS
	TEMP=0.0
	DO 250 K=1,nbands
	TEMP=TEMP+GAUSS(K,J)
250	CONTINUE
	GLINE(J)=TEMP
220	CONTINUE
C
C	SET CLEAR CONTINUUM POLYNOMIAL PARAMETERS
C
	IF(CONTYP.EQ.'P')GOTO 1000     ! polynomial in wavelength space
	IF(CONTYP.EQ.'Q')GOTO 1600     ! polynomial in wavenumber space
	IF(CONTYP.EQ.'S')GOTO 1300     ! STRAIGHT LINE REMOVAL IN WAVEL SPACE
	IF(CONTYP.EQ.'T')GOTO 1500     ! STRAIGHT LINE IN WAVEN SPACE
C
C	NO CONTINUUM	
C
	DO 800 K=1,NPNTS
	CONT(K)=0.0
800	CONTINUE
	GOTO 1400
C
C	POLYNOMIAL CONT IN WAVELENGTH SPACE
C
1000	continue
	do 1050 k=1,npnts
	W=WAVEL(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1050	CONTINUE
	GOTO 1400
C
C	POLYNOMIAL CONT IN WAVENUMBER SPACE
C
1600	continue
	do 1650 K=1,npnts
	W=WAVEN(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1650	CONTINUE
	GOTO 1400
C
C	STRAIGHT LINE CONTINUUM REMOVAL IN WAVELENGTH SPACE
C
1300	DO 1310 K=1,NPNTS
	W=WAVEL(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1310	CONTINUE
C
	GOTO 1400
C
C	STRAIGHT LINE CONTINUUM REMOVAL IN WAVENUMBER SPACE
C
1500	DO 1510 K=1,NPNTS
	W=WAVEN(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1510	CONTINUE
C
	GOTO 1400
C
1400	continue
C
C	CALCULATE FIT LINE
C
	DO 300 J=1,NPNTS
	FIT(J)=CONT(J)+GLINE(J)    ! FIT=GAUSS*CONT
300	CONTINUE
C
C	CALCULATE RESIDUAL AND REMAIN
C
	DO 320 J=1,NPNTS
	RESID(J)=RATIO(J)-FIT(J)
	RCONT(J)=RATIO(J)-CONT(J)
320	CONTINUE
C
	RETURN
	END
c
c
	subroutine filstat
c
c	subroutine to fill ipstat with derivative types
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),dispd,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
C
C
C	FILL THE TYPE PARTIAL DERIVATIVE ARRAY
C
C	1-nbands ARE CENTERS
C	nbands+1 - 2nbands ARE WIDTHS
C	2nbands+1 - 3bands ARE STRENGTHS
C
	DO 200 K=1,nbands
	IPSTAT(K,2)=1
	IPSTAT(nbands+K,2)=2
	IPSTAT(nbands+nbands+K,2)=3
200	CONTINUE
C
	IPSTAT(NPARAM+1,2)=4     ! CONSTANT
	IPSTAT(NPARAM+2,2)=5     ! X
	IPSTAT(NPARAM+3,2)=6     ! X*X
	IPSTAT(NPARAM+4,2)=7     ! X*X*X
C
	RETURN
	END
c
	subroutine shuffl
c
c	subroutine to fill the param array
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),dispd,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
C
	wconst=2.354820
C
C	FIRST CONVERT WAVEL TO WAVEN AND FWHM TO WIDTH
C
	DO 20 K=1,NPNTS
       	if(waven(k).ne.0)WVRT(K)=1.0/WAVEN(K)*1.0E+7    ! 
20	CONTINUE
C
	DO 50 K=1,nbands
	  IF(ISCAN.EQ.3)GCENTN(K)=GCENT(K)
	  IF(ISCAN.NE.3)GCENTN(K)=WLTOWN(GCENT(K))
	  GWIDTH(K)=GFWHM(K)/WCONST
C
	  if(gcentn(k).ne.0)CNRT(K)=1.0/GCENTN(K)*1.0E+7     ! 
	  SGRT(K)=GWIDTH(K)            ! to be determined
	  SGSQ(K)=SGRT(K)*SGRT(K)*-2.0    ! -2.0 * SIGMA SQUARED
C
50	CONTINUE
C
C	FILL THE PARAM ARRAY
C	1-nbands ARE CENTERS
C	nbands+1 - 2nbands ARE WIDTHS
C	2nbands+1 - 3bands ARE STRENGTHS
C
	DO 200 K=1,nbands
	PARAMS(K)=GCENTN(K)	
	PARAMS(nbands+K)=GWIDTH(K)
	PARAMS(nbands+nbands+K)=GSTR(K)
200	CONTINUE
C
	PARAMS(NPARAM+1)=CP0
	PARAMS(NPARAM+2)=CP1
	PARAMS(NPARAM+3)=CP2    ! STORE THE CONT/BASELINE PARAMS
	PARAMS(NPARAM+4)=CP3
C
	do 300 k=1,nparam+4
	  param0(k)=params(K)   ! store the original parameters
 300	continue
C
	RETURN
	END
c
	subroutine unshuffl
c
c	subroutine to put param array back to individual
c	gaussian arrays
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	real*8 g(1536,94)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),dispd,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	wconst=2.354820
c
c	unshuffl the params
c
	DO 100 K=1,nbands
	GCENTN(K)=PARAMS(K)
	GWIDTH(K)=PARAMS(nbands+K)
	GFWHM(K)=GWIDTH(K)*WCONST
	GSTR(K)=PARAMS(nbands+nbands+K)
C
	IF(ISCAN.EQ.3)GCENT(K)=GCENTN(K)
	IF(ISCAN.NE.3)GCENT(K)=WNTOWL(GCENTN(K))
C
100	CONTINUE
C
C
	CP0=PARAMS(NPARAM+1)
	CP1=PARAMS(NPARAM+2)
	CP2=PARAMS(NPARAM+3)         ! UNSTORE THE CONT/BASELINE PARAMS
	CP3=PARAMS(NPARAM+4)
C
	RETURN
	END
