c
	subroutine listpar
c
c	subroutine to list all the parameters to the screen
c
c	ipmin,ipmax,ivtic   for  display
c	ihmin,ihmax,ihtic   for display
c	baseline constant
c	type of continuum   g gaussain  p polynomial   n none  s straight line
c       p0,p1,p2  for continuum
c	number of gaussians
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	etc
c
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 bands(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50)
	logical*1 disps,dispf,disprs,dispg,dispc,
	2  dispd,disprm,contyp,dispi
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	LOGICAL*1 ITIME(8),YES,NO,ANSWERS(12)
	LOGICAL*1 IHY,IHN,IHX,IB,IDATE(9),ESCAPE
	LOGICAL*1 TEXT(72,16)
	LOGICAL*1 DOT,DBYTE,ABYTE,TBYTE
	LOGICAL*1 STB(6)   ! SIDERIAL TIM HHMMSS
C
	DATA YES,NO,IHX/'Y','N',1HX/
C
	CALL DATE(IDATE)
C
	call clrscr
c
	CALL TIME(ITIME)
C
	WRITE(*,9000)IDATE,ITIME
9000	FORMAT(//1X,9A1,8X,'=====  MGM-Fit Parameters  '
	1 ,'=====',8X,8A1)
c
c	now dump out the current parameters
c
	write(*,9020)ipmin,ipmax,ivtic,iwmin,iwmax,ihtic
9020	format(//' Display Parameters:  Vertical   '3I7,/
	2          '                      Horizontal '3I7/)
c
c	baseline continuum list	
c	
	IF(CONTYP.EQ.'N')write(*,9040)
	IF(CONTYP.EQ.'P')write(*,9045)
	IF(CONTYP.EQ.'Q')write(*,9050)
	IF(CONTYP.EQ.'G')write(*,9055)
	IF(CONTYP.EQ.'S')write(*,9060)swav1,swav2
	IF(CONTYP.EQ.'T')write(*,9065)swav1,swav2
	if(contyp.ne.'N')write(*,9070)cp0,cp1,cp2,cp3
c
9040	format(' No Continuum')
9045	format(' Polynomial Continuum in Wavelength Space')
9050	format(' Polynomial Continuum in Wavenumber Space')
9055	format(' Gaussian Continuum')
9060	format(' Straight line removed in Wavelength '2F7.1)
9065	format(' Straight line removed in Wavenumber '2F7.1)
9070	format(' P0= 'E15.8' P1= 'E15.8' P2= 'E15.8' P3= 'E15.8)
c
c	now list bands
c
	write(*,9080)nbands
9080	format(/,2X,I4' Absorption Bands'/)
9090	format(2X,I2'  Center= 'E15.8'   FWHM= 'E15.8'   Str= 'E15.8)
c   
	do 200 k=1,nbands
	write(*,9090)k,gcent(k),gfwhm(k),gstr(k)
200	continue
c
c	write error
c
	ipts=npnts
	rmscur=rmserr(IPTS,FIT,RATIO)
C
	write(*,9110)rmscur
9110	format(/' Current RMS Error 'E12.6)
c
	read(*,9105)idum
9105	format(I4)
	return
	end
c
	subroutine dumpar
c
c	subroutine to list all the parameters to FOR004.dat
c
c	ipmin,ipmax,ivtic   for  display
c	ihmin,ihmax,ihtic   for display
c	baseline constant
c	type of continuum   g gaussians  p polynomial   n none  s straight line
c       p0,p1,p2  for continuum
c	number of bands
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	etc
c
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 bands(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
C
	real*4 gsum,cntmin,cntmax    ! log area of band
c
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50)
	logical*1 disps,dispf,disprs,dispg,dispc,
	2  dispd,disprm,contyp,dispi
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	LOGICAL*1 ITIME(8),YES,NO,ANSWERS(12)
	LOGICAL*1 IHY,IHN,IHX,IB,IDATE(9),ESCAPE
	LOGICAL*1 TEXT(72,16)
	LOGICAL*1 DOT,DBYTE,ABYTE,TBYTE
	LOGICAL*1 STB(6)   ! SIDERIAL TIM HHMMSS
C
	integer nparus
	real*8 gtg(94,94),gtginv(94,94),indx(94),temp
	real*8 temp1,g(1536,94)
	real std(94)
C
	DATA YES,NO,IHX/'Y','N',1HX/
C
	CALL DATE(IDATE)
	CALL TIME(ITIME)
C
	WRITE(4,9000)IDATE,ITIME
9000	FORMAT(//1X,9A1,8X,'=====  MGM-Fit Parameters  '
	1 ,'=====',8X,8A1)
c
c	now dump out the current parameters
c
	write(4,9020)ipmin,ipmax,ivtic,iwmin,iwmax,ihtic
9020	format(//' Display Parameters:  Vertical   '3I7,/
	2          '                      Horizontal '3I7/)
c
c	baseline continuum list	
c	
	IF(CONTYP.EQ.'N')write(4,9040)
	IF(CONTYP.EQ.'P')write(4,9045)
	IF(CONTYP.EQ.'Q')write(4,9050)
	IF(CONTYP.EQ.'G')write(4,9055)
	IF(CONTYP.EQ.'S')write(4,9060)swav1,swav2
	IF(CONTYP.EQ.'T')write(4,9065)swav1,swav2
	if(contyp.ne.'N')write(4,9070)cp0,cp1,cp2,cp3
c
9040	format(' No Continuum')
9045	format(' Polynomial Continuum in Wavelength Space')
9050	format(' Polynomial Continuum in Wavenumber Space')
9055	format(' Gaussian Continuum')
9060	format(' Straight line removed in Wavelength '2F7.1)
9065	format(' Straight line removed in Wavenumber '2F7.1)
9070	format(/' P0= 'E15.8' P1= 'E15.8' P2= 'E15.8' P3= 'E15.8)
c
c	now list bands
c
	write(4,9080)nbands
9080	format(/,2X,I4' Absorption Bands'/)
c   
	write(4,9082)
9082	format(2x,'#',8x,'Center'13x'FWHM'12x'Strength'10x'Log Area'/)
9090	format(I3,3x,E15.8,3x,E15.8,3x,E15.8,3x,E15.8)
c
	do 200 k=1,nbands
c
	gsum=0
	do 205 jj=1,npnts
	gsum=gsum+bands(k,jj)
205	continue
c
	write(4,9090)k,gcent(k),gfwhm(k),gstr(k),gsum
200	continue
c
c	write error
c
	ipts=npnts
	rmscur=rmserr(IPTS,FIT,RATIO)
C
	write(4,9110)rmscur
9110	format(/' Current RMS Error 'E12.6)
	rmscur=sqrt((rmserr(IPTS,FIT,RATIO)**2)*npnts/(npnts-nparam))
C
C	calculate GTG
C
	do 125 i=1,nparus
	  do 126 j=1,nparus
	    temp=0.0
	    do 127 k=1,npnts
	      temp=temp+(g(k,i)*g(k,j))
 127	    continue
	    gtg(i,j)=temp
 126	  continue
 125	continue
C
C	get GTGinv
C
	do 120 i=1,nparus
	  do 121 j=1,nparus
	    gtginv(i,j)=0.0
  121     continue
 	  gtginv(i,i)=1.0
 120	continue
	call dludcmp(gtg,nparus,94,indx,d1)
	do 122 j=1,nparus
	  call dlubksb(gtg,nparus,94,indx,gtginv(1,J))
 122	continue
c
c   	print out gtg diagonals
c
c	do 131 i=1,nparus
c	 std(i)=sngl(gtg(i,i))
c 131    continue
c	call wropt(-6,2,0)
c	call wrrrn('gtg diagonals',1,nparus,std,1,0)
c
	do 130 i=1,nparus
 	 std(i)=1.96*sqrt(sngl(gtginv(i,i))*rmscur**2) ! 1.96*st dev
 130    continue                                       ! 95% conf.
c	call wropt(-6,2,0)
c	call wrrrn('standard deviation',1,nparus,std,1,0)
c
c	write model parameter (+/- 1.96 stnd commented out)	
c
c	baseline continuum list	
c	
	if(contyp.ne.'N')write(9,8070)(cp0-std(3*nbands+1)),
     &  (std(3*nbands+1)+cp0)
	if(contyp.ne.'N')write(9,8071)(cp1-std(3*nbands+2)),
     &  (std(3*nbands+2)+cp1)
	if(contyp.ne.'N')write(9,8072)(cp2-std(3*nbands+3)),
     &  (std(3*nbands+3)+cp2)
	if(contyp.ne.'N')write(9,8073)(cp3-std(3*nbands+4)),
     &  (std(3*nbands+4)+cp3)
c
8070	format(/2x,E12.2,' <P0< ',E12.2) 
8071	format(/2x,E12.2,' <P1< ',E12.2) 
8072	format(/2x,E12.2,' <P2< ',E12.2) 
8073	format(/2x,E12.2,' <P3< ',E12.2) 
c
c	now list bands
c
c   
	write(9,*)
	do 201 k=1,nbands
8090	format(I3,2x,F8.2,' <c< ',f8.2,2x,f6.2,' <w< ',f6.2,
     &  2x,f7.4,' <s< ',f7.4)
c
c 			convert stnd error wn to wlength
c
	cntmax=1.0/(1.0/gcent(k)-std(k)*1E-7)
	cntmin=1.0/(1.0/gcent(k)+std(k)*1E-7)
c
     	write(9,8090)k,cntmin,cntmax,
     &  (gfwhm(k)-std(nbands+k)),(std(nbands+k)+gfwhm(k)),
     &  (gstr(k)-std(2*nbands+k)),(std(2*nbands+k)+gstr(k))
201	continue
	return
	end
c
c
c
	subroutine liststat
c
c	subroutine to list locked/unlocked status of all the parameters
c	to the screen
c
c	ipmin,ipmax,ivtic   for  display
c	ihmin,ihmax,ihtic   for display
c	baseline constant
c	type of continuum   g gaussian  p polynomial   n none  s straight line
c       p0,p1,p2  for continuum
c	number of bands
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	etc
c
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 bands(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50)
	logical*1 disps,dispf,disprs,dispg,dispc,
	2  dispd,disprm,contyp,dispi
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2,IDUM
C
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	LOGICAL*1 ITIME(8),YES,NO,ANSWERS(12)
	LOGICAL*1 IHY,IHN,IHX,IB,IDATE(9),ESCAPE
	LOGICAL*1 TEXT(72,16)
	LOGICAL*1 DOT,DBYTE,ABYTE,TBYTE
	LOGICAL*1 STB(6)   ! SIDERIAL TIM HHMMSS
C
	DATA YES,NO,IHX/'Y','N',1HX/
C
	CALL DATE(IDATE)
C
	call clrscr
c
	CALL TIME(ITIME)
C
	WRITE(*,9000)IDATE,ITIME
9000	FORMAT(//1X,9A1,8X,'=====  Parameter Status  '
	1 ,'=====',8X,8A1)
c
c	now dump out the current parameters
c
c
c	list bands
c
	write(*,9080)
	write(*,9090)
9080	format(//,28X'Absorption Bands'/)
9090	format(4X,'#',9X'Center'11X'FWHM'10X'Strength'/)
c   
	do 200 k=1,nbands
c
	write(*,9100)k
c
	i1=k
	i2=k+nbands
	i3=k+nbands+nbands
	if(ipstat(i1,1).eq.0)write(*,9102)
	if(ipstat(i1,1).ne.0)write(*,9104)
	if(ipstat(i2,1).eq.0)write(*,9102)
	if(ipstat(i2,1).ne.0)write(*,9104)
	if(ipstat(i3,1).eq.0)write(*,9102)
	if(ipstat(i3,1).ne.0)write(*,9104)
200	continue
9100	format(2X,I3,$)
9102	format('+',8x,'Unlocked'$)
9104	format('+',8x,' Locked '$)
c
c	write error
c
	if(contyp.eq.'N')GOTO 400
c
	write(*,9114)
9114	format(/13X'Continuum Parameters'//
	2        10X'C0'12X'C1'12X'C2'12X'C3'/)
c
	if(ipstat(nparam+1,1).eq.0)write(*,9120)
	if(ipstat(nparam+1,1).ne.0)write(*,9121)
	if(ipstat(nparam+2,1).eq.0)write(*,9120)
	if(ipstat(nparam+2,1).ne.0)write(*,9121)
	if(ipstat(nparam+3,1).eq.0)write(*,9120)
	if(ipstat(nparam+3,1).ne.0)write(*,9121)
	if(ipstat(nparam+4,1).eq.0)write(*,9120)
	if(ipstat(nparam+4,1).ne.0)write(*,9121)
c
9120	format('+',6x,'Unlocked'$)
9121	format('+',6x,' Locked '$)
c
400	continue
	read(*,9300)idum
9300	format(I1)
c
	return
	end
