c
c	MAIN ROUTINE FOR MGM-FIT
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 bands(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536),daterr(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
c	roots contain par **-2.0  
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT,RTEMP(1536)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	integer nparus
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC,IHTC
	LOGICAL*1 TITLE(50),ANSWERS(12),IDATE(9),ITIME(8),YES,NO,dispd
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,dispi,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
	DATA      YES,NO/'Y','N'/
C
C
	disps=yes                  ! display spectra
	dispc=yes                  ! display continuum
	dispf=yes                  ! display fit
	disprs=yes                 ! display residual
	dispi=yes                  ! display individual
C
	CALL STARTUP
C
C	SET INITIAL ERROR LIMITS
C
	IRESL=ABS(WAVEL(2)-WAVEL(1))
	IF(IRESL.LE.1)IRESL=1
	IFITRES=IRESL
	ISAMPRES=IFITRES/IRESL   ! CALCULATE FIT FREQUENCY
	IPTS=NPNTS
	RMSOLD=RMSERR(IPTS,FIT,RATIO)
c	RMSLIM=0.0020     ! <1/4 % RMS ERROR
c	RIMPLIM=1.0E-8    ! SET IMPROVEMENT LIMIT TO 7 SIG FIG
	CALL DATE(IDATE)
C
10	CALL CLRSCR
	CALL TIME(ITIME)
	WRITE(5,9000)IDATE,ITIME
9000	FORMAT(/3X,9A1,6X,'======= MGM-FIT 2.0  Main Menu   '
	1 ,'========',6X,8A1,/)
	WRITE(5,9001)
9001	FORMAT('   By Jessica Sunshine and Stephen Pratt -- '
	1 ,'Brown University'/)
C	write menu
C
	WRITE(*,9700)
9700	FORMAT(/,'   Select: 1-Display Current Parameters'/
	2         '           2-Fit Once'/
	2         '           3-Fit Until'/
	2         '           4-Add/Del/Ch a Parameter'/
	2         '           5-Lock/Unlock a Parameter'/
	2         '           6-Display Routines'/
	2         '           7-Storage Routines (Ref.)'/
	2         '           8-Storage Routines (Log)'/
	2         '           9-Display Parameter Status'/
	2         '          10-Set Fit Resolution'/
	2         '          11-Stop  > '$)
C
	READ(*,8020,ERR=10)I1
8020	FORMAT(2I6)
C
	IF(I1.LT.1.OR.I1.GT.11)GOTO 10
C
	GOTO(100,200,250,300,400,500,600,700,900,950,1000)I1
C
C	LIST CURRENT PARAMETERS
C
100	CONTINUE
	CALL LISTPAR
	GOTO 10
C
C	CALL FIT
C
200	CALL stocFIT(ISAMPRES,0)    ! one fit
	GOTO 10
250	CALL stocFIT(ISAMPRES,1)
	GOTO 10
C
C	CHANGE/DEL/ADD A BAND
C
300	CONTINUE
	CALL CHPAR
	GOTO 10
C
C	LOCK/UNLOCK PARAMETERS
C
400	CONTINUE
	CALL LOCKUP
	GOTO 10
C
C	DISPLAY ROUTINES
C
500	CALL DISPLAY
	GOTO 10
C
C	
C
600	CONTINUE
	CALL STORCURV1
	GOTO 10
C
C	
C
700	CONTINUE
	CALL STORCURV2
	GOTO 10
C
C	
C
900	CONTINUE
	CALL LISTSTAT
	GOTO 10
C
950	IRESL=ABS(WAVEL(2)-WAVEL(1))
	WRITE(*,9800)IRESL,IFITRES
	READ(*,9802,ERR=950)IFITRES
9800	FORMAT(/' Spectrum Resolution'I4' Nm.  Fitting Resolution'I4' Nm.',
	2      /' Enter Fitting Resolution in Nanometers: '$)
9802	FORMAT(I6)
	IF(IFITRES.LT.1)IFITRES=IRESL
	ISAMPRES=IFITRES/IRESL   ! CALCULATE FIT FREQUENCY
	IF(ISAMPRES.LE.1)ISAMPRES=1
	GOTO 10
C
C
1000	CONTINUE
	CALL DUMPAR                ! DUMP FINAL RESULTS
c	call dump_final
C
	STOP
	END
