c
	subroutine storcurv1
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT,RTEMP(1536)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC,IHTC
	LOGICAL*1 TITLE(50),IDATE(9),ITIME(8),YES,NO,ANS,dispd
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,dispi,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
	CHARACTER HEAD*4,TAIL*3,FILE*8
	DATA      YES,NO/'Y','N'/
C
C
	CALL DATE(IDATE)
	CALL CLRSCR
C
	CALL TIME(ITIME)
	WRITE(*,9000)idate,itime
9000	FORMAT(//6X,9A1,4X,'======  Reflectance Storage Routines  '
	1 ,'======',4X,8A1,//)
c
	WRITE(*,9052)
9052	FORMAT(/'  Enter Header for Data Files (4 Char Max.) ' $)
	READ(*,9053)HEAD
9053	FORMAT(A4)
C
C	write menu
C
10	continue
	CALL CLRSCR
C
	CALL TIME(ITIME)
	WRITE(*,9000)idate,itime
	WRITE(*,9700)
9700	FORMAT(//,'   Select: 1-Save Fit'/
	2         '           2-Save Continuum'/
	2         '           3-Save Combined Bands'/
	2         '           4-Save Individual Bands'/
	2         '           5-Save Residual (Spectra-Fit)'/
	2         '           6-Save Spectra-Continuum'/
	2         '           7-Main Menu     > '$)
C
	READ(*,8020,ERR=10)I1
8020	FORMAT(2I6)
C
	IF(I1.LT.1.OR.I1.GT.7)GOTO 10
C
	GOTO(100,200,300,400,500,700,800)I1
C
C
C	SAVE FIT
C
100	CONTINUE
	DO 110 K=1,NPNTS
	RTEMP(K)=EXP(FIT(K))
110	CONTINUE
C
	FILE=HEAD//'FT'
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE)
	GOTO 10
C
C	SAVE CONTINUUM
C
200	CONTINUE
	FILE=HEAD//'CT'
	DO 210 K=1,NPNTS
	RTEMP(K)=EXP(CONT(K))
210	CONTINUE
C
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE)
	GOTO 10
C
C	COMBINED ABSORPTIONS
C
300	CONTINUE
	FILE=HEAD//'CG'
	DO 310 K=1,NPNTS
	RTEMP(K)=EXP(GLINE(K))
310	CONTINUE
C
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE)
	GOTO 10
C
C	INDIVIDUAL ABSORPTIONS
C
400	CONTINUE
C	
	DO 490 KK=1,nbands
	WRITE(*,9050)KK
9050	FORMAT('  Storing Band # 'I2)
	iwhich=kk
	P1=GCENT(IWHICH)
	P2=GFWHM(IWHICH)
	P3=EXP(GSTR(IWHICH))
	WRITE(*,8030)iwhich,P1,P2,P3
8030	FORMAT(2x,i2'  Center 'F10.4'   FWHM 'F12.4'   Str. 'F8.5)
	ENCODE(3,9056,TAIL)KK
9056	FORMAT(I3)
	TAIL(1:1)='G'
	IF(KK.LT.10)TAIL(2:2)='0'
	FILE=HEAD//TAIL
C
C	MOVE CHOSEN BAND TO TEMP STORAGE
C
	DO 420 K=1,NPNTS
	RTEMP(K)=GAUSS(IWHICH,K)
	RTEMP(K)=EXP(RTEMP(K))
420	CONTINUE
C
	CALL WRITEGAUS(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE,P1,P2,P3)
C
490	CONTINUE
	GOTO 10
C
C	RESIDUAL (RATIO-FIT)
C
500	CONTINUE
	FILE=HEAD//'RS'
	DO 510 K=1,NPNTS
	RTEMP(K)=EXP(ratio(k))-exp(fit(k))
510	CONTINUE
C
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE)
	GOTO 10
C
C	SAVE RATIO-CONT
C
700	CONTINUE
C
	FILE=HEAD//'NS'
	DO 710 K=1,NPNTS
	RTEMP(K)=EXP(RCONT(K))
710	CONTINUE
C
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE)
	GOTO 10
C
C	ALL DONE HERE
C
800	RETURN
	END
c
	subroutine storcurv2
c
C	STORE STUFF IN LOG BASE E
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT,RTEMP(1536)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC,IHTC
	LOGICAL*1 TITLE(50),IDATE(9),ITIME(8),YES,NO,ANS,dispd
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,dispi,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
	CHARACTER HEAD*4,TAIL*3,FILE*8
	DATA      YES,NO/'Y','N'/
C
C
	CALL DATE(IDATE)
	CALL CLRSCR
C
	CALL TIME(ITIME)
	WRITE(*,9000)idate,itime
9000	FORMAT(//6X,9A1,4X,'======  Log Base e Storage Routines  '
	1 ,'======',4X,8A1,//)
	WRITE(*,9052)
9052	FORMAT(/'  Enter Header for Data Files (4 Char Max.) ' $)
	READ(*,9053)HEAD
9053	FORMAT(A4)
C
C	write menu
C
10	continue
	CALL CLRSCR
C
	CALL TIME(ITIME)
	WRITE(*,9000)idate,itime
	WRITE(*,9700)
9700	FORMAT(//,'   Select: 1-Save Fit'/
	2         '           2-Save Continuum'/
	2         '           3-Save Combined Bands'/
	2         '           4-Save Individual Bands'/
	2         '           5-Save Residual (Spectra-Fit)'/
	2         '           6-Save Spectra'/
	2         '           7-Save Ratio (Spectra-Cont)'/
	2         '           8-Main Menu     > '$)
C
	READ(*,8020,ERR=10)I1
8020	FORMAT(2I6)
C
	IF(I1.LT.1.OR.I1.GT.8)GOTO 10
C
	GOTO(100,200,300,400,500,600,700,800)I1
C
C
C	SAVE FIT
C
100	CONTINUE
	FILE=HEAD//'LFT'
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,FIT,VOLT,FILE)
	GOTO 10
C
C	SAVE CONTINUUM
C
200	CONTINUE
	FILE=HEAD//'LCT'
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,CONT,VOLT,FILE)
	GOTO 10
C
C	COMBINED BANDS
C
300	CONTINUE
	FILE=HEAD//'LCG'
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,GLINE,VOLT,FILE)
	GOTO 10
C
C	INDIVIDUAL BANDS
C
400	CONTINUE
C	
	DO 490 KK=1,nbands
	WRITE(*,9050)KK
9050	FORMAT('  Storing Band # 'I2)
	iwhich=kk
	P1=GCENT(IWHICH)
	P2=GFWHM(IWHICH)
	P3=GSTR(IWHICH)
	WRITE(*,8030)iwhich,P1,P2,P3
8030	FORMAT(2x,i2'  Center 'F10.4'   FWHM 'F12.4'   Str. 'F8.5)
	ENCODE(3,9056,TAIL)KK
9056	FORMAT(I3)
	TAIL(1:1)='L'
	IF(KK.LT.10)TAIL(2:2)='0'
	FILE=HEAD//TAIL
C
C	MOVE CHOSEN ABSORPTION TO TEMP STORAGE
C
	DO 420 K=1,NPNTS
	RTEMP(K)=GAUSS(IWHICH,K)
420	CONTINUE
C
	CALL WRITEGAUS(NPNTS,ISCAN,WAVEL,RTEMP,VOLT,FILE,P1,P2,P3)
C
490	CONTINUE
	GOTO 10
C
C	RESIDUAL (RATIO-FIT)
C
500	CONTINUE
	FILE=HEAD//'LRS'
       	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RESID,VOLT,FILE)
	GOTO 10
C
C	SAVE RATIO/FIT
C
600	CONTINUE
	FILE=HEAD//'LSP'
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RATIO,VOLT,FILE)
	GOTO 10
C
C	SAVE RATIO/CONT
C
700	CONTINUE
C
	FILE=HEAD//'LNS'
	CALL WRITEFILE(NPNTS,ISCAN,WAVEL,RCONT,VOLT,FILE)
	GOTO 10
C
C	ALL DONE HERE
C
800	RETURN
	END
C
C
	SUBROUTINE WRITEFILE(NPNTS,ISCIN,WAVIN,RATIN,VOLT,FILE)
C
	LOGICAL*1 SAMPLE,ITIME(8),IDATE(9),ESCAPE,TEXX(72,10),ANS
	REAL*4    VOLT,RATIN(1536),WAVIN(1536),wavout
	INTEGER*2 ISCAN,NPNTS,IRANGE(2),ISCIN
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	CHARACTER FILNAM*12,EXT*4,FILOUT*20,FILE*8
	DATA ESCAPE/O33/
C
	CALL DATE(IDATE)
	CALL TIME(ITIME)
C
	ISCAN=ISCIN
	IF(WAVIN(2)-WAVIN(1).LT.1.0)ISCAN=1     ! ANGSTROM RESOLUTION
	IF(ISCIN.EQ.3)ISCAN=3                   ! NO JUST INVERSE CENT
	IF(ISCAN.NE.1)IRANGE(1)=WAVIN(1)
	IF(ISCAN.EQ.1)IRANGE(1)=WAVIN(1)*10.
	IF(ISCAN.NE.1)IRANGE(2)=WAVIN(NPNTS)
	IF(ISCAN.EQ.1)IRANGE(2)=WAVIN(NPNTS)*10.
	IF(ISCAN.NE.1)IRESL=ABS(WAVIN(2)-WAVIN(1))
	IF(ISCAN.EQ.1)IRESL=(WAVIN(2)-WAVIN(1))*10.
	IF(VOLT.NE.0.888)VOLT=0.777
	IPOLAR=0
	IDTECT=2
	ILITE=2
	IGRAT=2
	SANGLE=30.0
	DANGLE=0.0
	ETIME=0.0
C
	WRITE(5,5000)
5000	FORMAT(/' Enter Text, terminate by  $  ,Return')
	DO 40 I=1,10
	WRITE(5,5040)
5040	FORMAT('$*')
	READ(5,5050)(TEXX(L,I),L=1,72)
5050	FORMAT(72A1)
	IF(TEXX(1,I).EQ.'$')GOTO 50
	IF(TEXX(1,I).EQ.' ')GOTO 50
	LINE=I
40	CONTINUE
50	CONTINUE
C
	EXT='.DAT'
	FILOUT=FILE//EXT
C
C	save new file and text
C
900	IBLK=1
	IOUNIT=1
	OPEN(UNIT=IOUNIT,STATUS='NEW',FILE=FILOUT,ACCESS='DIRECT',
	2 FORM='UNFORMATTED',RECL=128)
C
	CALL HDOUT1(BLOCK,LSTBYT,NPNTS,IDATE,ITIME,IRANGE,IRESL,
	2 ID1,ID2,SCLMAX,IPOLAR,SANGLE,DANGLE,LINE,VOLT)
C
C-----FLAG STORED IN THIRD DECIMAL PLACE OF "VOLT" TO SELECT
C-----ADDITIONAL READ STATEMENT FOR DATA BASE TYPE TWO
C
	IF(VOLT.EQ.0.111)CALL HDOUT3(BLOCK,LSTBYT,IRAH,IRAM,IRAS,
	2 IDEG,IDEM,IDES,IAIR,IERROR,TIMINT,STB)
C
	IF(VOLT.NE.0.111)CALL HDOUT2(BLOCK,LSTBYT,IDTECT,IGRAT,
	2 ISCAN,ILITE,BGND,SIG,SD1,SD2,ETIME)
C
	DO 990 J=1,LINE
	DO 995 J2=1,72
995	TXTIN(J2)=TEXX(J2,J)
C
	CALL TXTOUT(IOUNIT,IBLK,BLOCK,IOERR,LSTBYT,TXTIN)
C
990	CONTINUE
C
	DO 920 J=1,NPNTS
	wavout=wavin(j)
	IF(iscan.eq.1)wavout=wavout*10.
	LAMDA=WAVout
	CALL DATOUT(IOUNIT,IBLK,BLOCK,IOERR,LSTBYT,VOLT,
	2 LAMDA,RATIN(J),SAMP,STAND,BKGND)
920	CONTINUE
	WRITE(IOUNIT'IBLK)BLOCK  !  WRITE  OUT LAST BLOCK
905	CLOSE(UNIT=IOUNIT,DISP='KEEP')
C
	RETURN
	END
C
C
	SUBROUTINE WRITEGAUS(NPNTS,ISCIN,WAVIN,RATIN,VOLT,FILE,P1,P2,P3)
C
	LOGICAL*1 SAMPLE,ITIME(8),IDATE(9),ESCAPE,TEXX(72),ANS
	REAL*4    VOLT,RATIN(1536),WAVIN(1536),P1,P2,P3,wavout
	INTEGER*2 ISCAN,ISCIN,NPNTS,IRANGE(2)
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512),CEN(10),WID(10),STR(10)
	CHARACTER FILNAM*12,EXT*4,FILOUT*20,FILE*8
	DATA ESCAPE/O33/
	DATA TXTIN/'G','a','u','s','s','i','a','n',' ','w','i','t','h',
	2 ' ','C','e','n','t','e','r','=',' ',' ',' ',' ',' ',' ',' ',' ',
	2 ' ',' ',' ',' ',' ',' ','F','W','H','M','=',' ',' ',' ',' ',' ',
	2 ' ',' ',' ',' ',' ',' ',' ',' ',' ','S','t','r','.','=',' ',' ',
	2 ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '/
C
	CALL DATE(IDATE)
	CALL TIME(ITIME)
	ISCAN=ISCIN
	IF(WAVIN(2)-WAVIN(1).LT.1.0)ISCAN=1     ! ANGSTROM RESOLUTION
	IF(ISCIN.EQ.3)ISCAN=3                   ! NO JUST INVERSE CENT
	IF(ISCAN.NE.1)IRANGE(1)=WAVIN(1)
	IF(ISCAN.EQ.1)IRANGE(1)=WAVIN(1)*10.
	IF(ISCAN.NE.1)IRANGE(2)=WAVIN(NPNTS)
	IF(ISCAN.EQ.1)IRANGE(2)=WAVIN(NPNTS)*10.
	IF(ISCAN.NE.1)IRESL=ABS(WAVIN(2)-WAVIN(1))
	IF(ISCAN.EQ.1)IRESL=(WAVIN(2)-WAVIN(1))*10.
	IF(VOLT.NE.0.888)VOLT=0.777
	IPOLAR=0
	IDTECT=2
	ILITE=2
	IGRAT=2
	SANGLE=30.0
	DANGLE=0.0
	ETIME=0.0
C
	LINE=1
	ENCODE(10,9001,CEN)P1
	ENCODE(10,9001,WID)P2
	ENCODE(10,9003,STR)P3
9001	FORMAT(F10.4)
9003	FORMAT(F10.6)
C
	DO 20 K=1,10
	TXTIN(K+22)=CEN(K)
	TXTIN(K+41)=WID(K)
	TXTIN(K+60)=STR(K)
20	CONTINUE
C
	EXT='.DAT'
	FILOUT=FILE//EXT
C
C	save new file and text
C
900	IBLK=1
	IOUNIT=1
	OPEN(UNIT=IOUNIT,STATUS='NEW',FILE=FILOUT,ACCESS='DIRECT',
	2 FORM='UNFORMATTED',RECL=128)
C
	CALL HDOUT1(BLOCK,LSTBYT,NPNTS,IDATE,ITIME,IRANGE,IRESL,
	2 ID1,ID2,SCLMAX,IPOLAR,SANGLE,DANGLE,LINE,VOLT)
C
C-----FLAG STORED IN THIRD DECIMAL PLACE OF "VOLT" TO SELECT
C-----ADDITIONAL READ STATEMENT FOR DATA BASE TYPE TWO
C
	IF(VOLT.EQ.0.111)CALL HDOUT3(BLOCK,LSTBYT,IRAH,IRAM,IRAS,
	2 IDEG,IDEM,IDES,IAIR,IERROR,TIMINT,STB)
C
	IF(VOLT.NE.0.111)CALL HDOUT2(BLOCK,LSTBYT,IDTECT,IGRAT,
	2 ISCAN,ILITE,BGND,SIG,SD1,SD2,ETIME)
C
	CALL TXTOUT(IOUNIT,IBLK,BLOCK,IOERR,LSTBYT,TXTIN)
C
	DO 920 J=1,NPNTS
	wavout=wavin(j)
	IF(iscan.eq.1)wavout=wavout*10.
	LAMDA=WAVout
	CALL DATOUT(IOUNIT,IBLK,BLOCK,IOERR,LSTBYT,VOLT,
	2 LAMDA,RATIN(J),SAMP,STAND,BKGND)
920	CONTINUE
	WRITE(IOUNIT'IBLK)BLOCK  !  WRITE  OUT LAST BLOCK
905	CLOSE(UNIT=IOUNIT,DISP='KEEP')
C
	RETURN
	END
